<?php
/*
********************************************************************************
 ADVANCED FORM plugin for CMSimple
 ---------------------------------
 Author  :  Jan Kanters - jan.kanters@telenet.be or webmaster@jat-at-home.be
 Date    :  01/07/2005
 Version :  V 1.6.0
 Remarks :  Initial release Beta 1.00 on 04/06/2005
 For changes, please see changelog file
********************************************************************************
*/
if ($advancedform)
{ 
    // check if register_globals is turned OFF
    if (!ini_get ("register_globals"))
    {
        extract($HTTP_GET_VARS);
        extract($HTTP_POST_VARS);
        extract($HTTP_COOKIE_VARS);
        extract($HTTP_ENV_VARS);
        extract($HTTP_SERVER_VARS);
    } 
    ini_set('safe_mode', '1');
    ini_set('display_errors', '0');
    ini_set('display_startup_errors', '0');
    global $sn, $sv, $pth; //,$selectedform,$plugin;
    $action = isset($_POST['action']) ? $_POST['action'] : $_GET['action'];
    $admin = isset($_POST['admin']) ? $_POST['admin'] : $_GET['admin'];
    $a = isset($_POST['a']) ? $_POST['a'] : $_GET['a'];
    $rows = $_REQUEST['rows']; 
    // Create file location paths for the ADVANCEDFORM plugin
    $plugin = basename(dirname(__FILE__), "/");
    $pth['file']['plugin_config'] = $pth['folder']['plugins'] . $plugin . '/config/config.php';
    $pth['file']['plugin_language'] = $pth['folder']['plugins'] . $plugin . '/languages/' . $sl . '.php';
    $pth['file']['plugin_javascript'] = $pth['folder']['plugins'] . $plugin . '/forms.js';
    $pth['file']['plugin_builder'] = $pth['folder']['plugins'] . $plugin . '/properties.php';
    if (!@include($pth['file']['plugin_language']))die('Plugin Language file ' . $pth['file']['plugin_language'] . ' is missing');
    if (!@include($pth['file']['plugin_config']))die('Plugin Configuration file ' . $pth['file']['plugin_config'] . ' is missing');
    if (!is_file($pth['file']['plugin_javascript']))die('Plugin Javascript file ' . $pth['file']['plugin_javascript'] . ' is missing');
    if (!is_file($pth['file']['plugin_builder']))die('Plugin Fieldtype Properties builder file ' . $pth['file']['plugin_builder'] . ' is missing');
    $pth['folder']['pluginsdata'] = $pth['folder']['plugins'] . $plugin . "/data/";
    $pth['folder']['pluginsimages'] = $pth['folder']['plugins'] . $plugin . "/images/";
    if (is_file($pth['folder']['plugins'] . $plugin . '/help/'.$sl.'/help.htm'))
    {
        $pth['file']['plugin_help'] = $pth['folder']['plugins'] . $plugin . '/help/'.$sl.'/help.htm';
    }
    else
    {
        $pth['file']['plugin_help'] = $pth['folder']['plugins'] . $plugin . '/help/en/help.htm';
	}
    // Verify data files first
    clearstatcache(); 
    // Create an empty file forms.dat
    if (!file_exists($pth['folder']['pluginsdata'] . "forms.dat"))
    {
        $handle = fopen($pth['folder']['pluginsdata'] . "forms.dat", "wb+");
        fclose($handle);
    } 
    if (!file_exists($pth['folder']['pluginsdata'] . "formsdetails.dat"))
    {
        $handle = fopen($pth['folder']['pluginsdata'] . "formsdetails.dat", "wb+");
        fclose($handle);
    } 
    // Array for FIELD TYPES
    $aFieldType = array("Text", "Sender's name", "Sender's email", "Generic email", "Radio", "CheckBox", "Select", "Select Multiple", "TextArea", "No input", "Hidden"); 
    // Build the ADVANCEDFORM plugin Administration dropdown list
    $o .= "<table class='edit' width='100%' cellpadding='1' cellspacing='0' border='1' summary=''>
    <tr><td align=\"left\" width=\"45%\">" . strtoupper($plugin) . "</td>
    <td width=\"55%\"><select name=\"cboPluginOptions\" onchange=\"location.href=this.options[this.selectedIndex].value\"><option value=\"$sn?&amp;$plugin&amp;normal\">" . $plugin_tx[$plugin]['menu_choice'] . "</option>";
    $o .= "<option value=\"$sn?&amp;$plugin&amp;admin=plugin_main\"";
    if ($_GET['admin'] == 'plugin_main') $o .= "selected=\"   selected\"";
    $o .= ">" . ucfirst($plugin_tx[$plugin]['menu_main']) . "</option>";
    $o .= "<option value=\"$sn?&amp;$plugin&amp;admin=plugin_config&amp;action=plugin_edit\"";
    if ($_GET['admin'] == 'plugin_config') $o .= "selected=\"selected\"";
    $o .= ">" . ucfirst($plugin_tx[$plugin]['menu_config']) . "</option>";
    $o .= "<option value=\"$sn?&amp;$plugin&amp;admin=plugin_language&amp;action=plugin_edit\"";
    if ($_GET['admin'] == 'plugin_language') $o .= "selected=\"selected\"";
    $o .= ">" . ucfirst($plugin_tx[$plugin]['menu_language']) . "</option>";
    $o .= "</select>&nbsp;&nbsp;<a href=" . $pth['file']['plugin_help'] . " target=\"_blank\"><img src=\"" . $pth['folder']['pluginsimages'] . "btn_help.png\" alt=\"" . $plugin_tx[$plugin]['menu_help'] . "\" /></a></td></table>";
    $o .= "<div><small>Advanced Form plugin " . ADV_FORM_VERSION . " (dd/mm/yyyy) by <a href=\"http://www.jat-at-home.be\" target=\"_blank\">JAT</a></small></div>"; 
    // End ADVANCEDFORM plugin Administration dropdown list
    // Common ADMINSTRATION
    if ($admin == 'plugin_config')
    {
        $a = 'plugin_cf';
        $o .= plugin_admin_common($action, $admin, $plugin);
    } 
    if ($admin == 'plugin_language')
    {
        $a = 'plugin_tx';
        $o .= plugin_admin_common($action, $admin, $plugin);
    } 
    // End Common ADMINSTRATION
    // ADVANCEDFORM ADMINISTRATION
    if ($admin == 'plugin_main')
    {
        global $plugin, $FormDefinitionLineID, $FormFieldsLineID, $selectedform, $plugin_tx, $frmnew, $path, $sl; 
        // Read selected Form Definition settings into array (one for form definition / one for form fields of the selected form)
        if ($selectedform > 0 && ($action != "newform"))
        {
            global $tmpFormsName, $tmpFormsTitle, $tmpFormsNumberOfFields, $tmpFormsID, $DefinedForms, $frmnew;
            readFormDefinitions();
            if ($selectedform > 0 && $selectedform <= count($DefinedForms))
            {
                unset($FormDefinitionLineID);
                $FormDefinitionLineID = $selectedform-1;
                $formName = $tmpFormsName[$selectedform];
                $formTitle = $tmpFormsTitle[$selectedform];
                $numberOfFormFields = $tmpFormsNumberOfFields[$selectedform];
                $formID = $tmpFormsID[$selectedform];
                if (!isset($rows))
                {
                    $rows = $numberOfFormFields;
                } 
                else
                {
                    $numberOfFormFields = $rows;
                } 
                // Find matching Form Details Settings for the selected form
                $arrFormFields = file($pth['folder']['pluginsdata'] . "formsdetails.dat");
                for($tt = 0;$tt < count($arrFormFields);$tt++)
                {
                    $ReadFieldSettings = unserialize($arrFormFields[$tt]);
                    if ($ReadFieldSettings[0] == $formID)
                    { 
                        // Field settings found for the corresponding Form Definition file
                        unset($FormFieldsLineID);
                        $FormFieldsLineID = $tt;
                        break;
                    } 
                } 
                // Read saved Form Field settings into variables & display
                $ReadFieldSettings = unserialize($arrFormFields[$tt]);
                $t = 1;
                for($i = 1; $i <= $numberOfFormFields; $i++)
                {
                    $fieldLabel[$i] = $ReadFieldSettings[$t];
                    $t++;
                    $fieldName[$i] = $ReadFieldSettings[$t];
                    $t++;
                    $fieldType[$i] = str_replace("\\", "", $ReadFieldSettings[$t]);
                    $t++;
                    $fieldValue[$i] = $ReadFieldSettings[$t];
                    $t++;
                    $fieldRequired[$i] = $ReadFieldSettings[$t];
                    $t++;
                } 
            } 
            else
            {
                if ($selectedform != 0)
                {
                    $o .= e("", "", $plugin_tx[$plugin]['error_unknown_form']);
                } 
                else
                {
                    $selectedform = 0;
                    $FormDefinitionLineID = "";
                    $FormFieldsLineID = "";
                } 
            } 
        } 
        if (isset($action))
        {
            switch ($action)
            { 
                // Create an empty Form Definition
                case "newform":
                    global $selectedform, $old_selectedform;
                    $frmnew = 1;
                    $old_selectedform = $_REQUEST['selectedform'];
                    unset($FormDefinitionLineID);
                    unset($FormFieldsLineID);
                    unset($formName);
                    unset($formTitle);
                    unset($selectedform);
                    unset($cboDefinedForm);
                    unset($fieldLabel);
                    unset($fieldName);
                    unset($fieldType);
                    unset($fieldValue);
                    unset($fieldRequired);
                    unset($formID);
                    $numberOfFormFields = 2;
                    $rows = 2;
                    $formID = makeUniqueID();
                    $jat_url = html_entity_decode($sn . "?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $old_selectedform . "&amp;frmnew=" . $frmnew . "&amp;formID=" . $formID . "&amp;action=updatefields");
                    header("Location: $jat_url"); 
                    // echo "<script type='text/javascript'>location.href='$jat_url';</script>";
                    break;
                case "saveform": 
                    // Save (frmnew==1) of update (frmnew==0) form definition
                    global $formID, $frmnew, $FormDefinitionLineID, $cboDefinedForms;
                    $title = ucfirst($plugin_tx[$plugin]['forms_btn_save']); 
                    // Verify existing form has been selected
                    if ($FormDefinitionLineID == "" && $frmnew != 1)
                    {
                        $o = "<br />";
                        $o .= '<h4>' . $title . '</h4>' ;
                        $o .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"\">";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td>" . $plugin_tx[$plugin]['error_no_form_selected'] . "</td></tr>";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_goback'] . "\" onclick='javascript:history.back()' /></td></tr>";
                        $o .= "</form></table>";
                        break;
                    } 
                    // Some validation before saving the settings
                    // Check for valid Form Name
                    if (trim($formName) == "" || !isset($formName))
                    { 
                        // Error message no valid Form Name
                        $o = "<br />";
                        $o .= '<h4>' . $title . '</h4>' ;
                        $o .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"\">";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td>" . $plugin_tx[$plugin]['error_no_form_name'] . "</td></tr>";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_goback'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main&amp;selectedform=$selectedform\"' /></td></tr>";
                        $o .= "</form></table>";
                        break;
                    } 
                    // Check unique Form Name
                    unset($arrForms, $formNameExists);
                    if ($arrForms = file($pth['folder']['pluginsdata'] . "forms.dat"))
                    {
                        $maxForms = count($arrForms);
                        for ($t = 0;$t < $maxForms;$t++)
                        {
                            if ($t != $FormDefinitionLineID || $FormDefinitionLineID == "")
                            {
                                $searchformName = unserialize($arrForms[$t]);
                                if (trim($searchformName[0]) == trim($formName))
                                {
                                    $selectedform = $t + 1;
                                    $formNameExists = true;
                                    break;
                                } 
                            } 
                        } 
                    } 
                    else
                    {
                        $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                    } 
                    unset($arrForms);
                    if ($formNameExists == true)
                    { 
                        // Error message Form Exists
                        $o = "<br />";
                        $o .= '<h4>' . $title . '</h4>' ;
                        $o .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"\">";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td>" . $plugin_tx[$plugin]['error_file_exists1'] . " <b>" . $formName . "</b> " . $plugin_tx[$plugin]['error_file_exists2'] . "</td></tr>";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_goback'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main&amp;selectedform=$selectedform\"' /></td></tr>";
                        $o .= "</form></table>";
                    } 
                    else
                    {
                        for($i = 1; $i <= $numberOfFormFields; $i++)
                        {
                            if (empty($fieldLabel[$i]) || empty($fieldName[$i]) || !isset($fieldLabel[$i]) || !isset($fieldName[$i]) || $fieldLabel[$i] == '' || $fieldName[$i] == '')
                            { 
                                // Error message empty fieldname or fieldlabel
                                $o = "<br />";
                                $o .= '<h4>' . $title . '</h4>' ;
                                $o .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"\">";
                                $o .= "<tr><td>&nbsp;</td></tr>";
                                $o .= "<tr><td>" . $plugin_tx[$plugin]['error_empty_field1'] . " <b>" . $fieldName[$i] . "</b> " . $plugin_tx[$plugin]['error_empty_field2'] . "</td></tr>";
                                $o .= "<tr><td>&nbsp;</td></tr>";
                                $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_goback'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main&amp;selectedform=$cboDefinedForms\"' /></td></tr>";
                                $o .= "</form></table>";
                                return $o;
                            } 
                        } 
                        // Store current Form Definition fields in array $arrForms
                        $arrForms[] = $formName;
                        $arrForms[] = $formTitle;
                        $arrForms[] = $numberOfFormFields;
                        $formID = ($frmnew == 1)?makeUniqueID():$formID;
                        $arrForms[] = $formID; 
                        // Storage format structure: formName - formDescription - numberOfFormFields - formID
                        $SaveFormDefinition = serialize($arrForms);
                        if ($frmnew == 1)
                        { 
                            // SAVE the NEW Form Definition in the forms.dat file
                            unset($SaveForm);
                            if ($SaveForm = fopen($pth['folder']['pluginsdata'] . "forms.dat", "ab"))
                            {
                                if (!fputs($SaveForm, $SaveFormDefinition . "\n"))
                                {
                                    $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                } ;
                                fclose($SaveForm);
                            } 
                            else
                            {
                                $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                            } 
                        } 
                        else
                        { 
                            // UPDATE the EXISTING Form Definition in the forms.dat file
                            // Load all form definitions in an array $arrForms
                            if ($arrForms = file($pth['folder']['pluginsdata'] . "forms.dat"))
                            { 
                                // Replace the current modified Form Definition
                                $arrForms[$FormDefinitionLineID] = $SaveFormDefinition;
                                unset($UpdateForm);
                                if (fopen($pth['folder']['pluginsdata'] . "forms.dat", "w+") != false)
                                {
                                    $UpdateForm = fopen($pth['folder']['pluginsdata'] . "forms.dat", "w+");
                                    $maxForms = count($arrForms);
                                    for ($t = 0;$t < $maxForms;$t++)
                                    {
                                        if (!fputs($UpdateForm, rtrim($arrForms[$t]) . "\n"))
                                        {
                                            $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                        } 
                                    } 
                                    fclose($UpdateForm);
                                } 
                                else
                                {
                                    $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                } 
                            } 
                            else
                            {
                                $$o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                            } 
                        } 
                        // Store current Form Fields settings into an array $arrFormFields
                        $arrFormFields[] = $formID;
                        for($i = 1; $i <= $numberOfFormFields; $i++)
                        {
                            $arrFormFields[] = $fieldLabel[$i];
                            $arrFormFields[] = $fieldName[$i];
                            $arrFormFields[] = $fieldType[$i];
                            $arrFormFields[] = stripslashes($fieldValue[$i]);
                            $arrFormFields[] = $fieldRequired[$i];
                        } 
                        // Save or Update the Form Field Settings to the file formsdetails.dat
                        // Storage format: formID - x times (fieldLabel - fieldName - fieldType - fieldValue - fieldRequired )
                        $SaveFieldSettings = serialize($arrFormFields);
                        if ($frmnew == 1)
                        { 
                            // SAVE NEW Form Field settings
                            if ($SaveFields = fopen($pth['folder']['pluginsdata'] . "formsdetails.dat", "a"))
                            {
                                if (!fputs($SaveFields, $SaveFieldSettings . "\n"))
                                {
                                    $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                } 
                                fclose($SaveFields);
                                $o = errorbox($plugin_tx[$plugin]['forms_btn_save'], $plugin_tx[$plugin]['msg_save_form1'] . " <b>" . $formName . "</b> " . $plugin_tx[$plugin]['msg_save_form2'], $cboDefinedForms);
                            } 
                            else
                            {
                                $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                            } 
                        } 
                        else
                        { 
                            // UPDATE EXISTING Field settings
                            if ($arrFormFields = file($pth['folder']['pluginsdata'] . "formsdetails.dat"))
                            {
                                $arrFormFields[$FormFieldsLineID] = $SaveFieldSettings;
                                unset($UpdateFields);
                                if (fopen($pth['folder']['pluginsdata'] . "formsdetails.dat", "wb+"))
                                {
                                    $UpdateFields = fopen($pth['folder']['pluginsdata'] . "formsdetails.dat", "wb+");
                                    $maxFormFields = count($arrFormFields);
                                    for ($t = 0;$t < $maxFormFields;$t++)
                                    {
                                        if (!fputs($UpdateFields, rtrim($arrFormFields[$t]) . "\n"))
                                        {
                                            $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>formsdetails.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                        } 
                                    } 
                                    fclose($UpdateFields); 
                                    // All data has been saved to both forms.dat & formsdetails.dat
                                    $o = errorbox($plugin_tx[$plugin]['forms_btn_save'], $plugin_tx[$plugin]['msg_save_form1'] . " <b>" . $formName . "</b> " . $plugin_tx[$plugin]['msg_save_form2'], $cboDefinedForms);
                                } 
                                else
                                {
                                    $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>formsdetails.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                                } 
                            } 
                            else
                            {
                                $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                            } 
                        } 
                        readFormDefinitions();
                        $frmnew = 0;
                    } 
                    break;
                case "deleteform":
                    $title = ucfirst($plugin_tx[$plugin]['forms_btn_delete']);
                    $o = "<br />";
                    $o .= '<h4>' . $title . '</h4>' ;
                    $o .= "<br />";
                    if ($frmdelete == 1)
                    { 
                        // Store all Form Definitions in an array $arrForms
                        if ($arrForms = file($pth['folder']['pluginsdata'] . "forms.dat"))
                        { 
                            // Create an empty Form Definitions file
                            if ($UpdateForms = fopen($pth['folder']['pluginsdata'] . "forms.dat", "wb"))
                            {
                                $maxForms = count($arrForms);
                                for($t = 0;$t < $maxForms;$t++)
                                { 
                                    // Write all Form Definitions to the file, except the selected (to be deleted) one
                                    if ($t != $FormDefinitionLineID)
                                    {
                                        if (!fputs($UpdateForms, rtrim($arrForms[$t]) . "\n"))
                                        {
                                            $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                        } 
                                    } 
                                } 
                                fclose($UpdateForms); 
                                // Store all Form Details in an array $arrFormDetails
                                if ($arrFormDetails = file($pth['folder']['pluginsdata'] . "formsdetails.dat"))
                                { 
                                    // Create an empty Form Details file
                                    if ($UpdateFormDetails = fopen($pth['folder']['pluginsdata'] . "formsdetails.dat", "wb"))
                                    {
                                        $maxFormFields = count($arrFormDetails);
                                        for($t = 0;$t < $maxFormFields;$t++)
                                        { 
                                            // Write all Form Details to the file, except the selected (to be deleted) one
                                            if ($t != $FormFieldsLineID)
                                            {
                                                if (!fputs($UpdateFormDetails, rtrim($arrFormDetails[$t]) . "\n"))
                                                {
                                                    $o = errorbox($title, $plugin_tx[$plugin]['error_save_file1'] . " <b>formsdetails.dat</b> " . $plugin_tx[$plugin]['error_save_file2'], $cboDefinedForms);
                                                } 
                                            } 
                                        } 
                                        fclose($UpdateFormDetails);
                                    } 
                                } 
                                else
                                {
                                    $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>formsdetails.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                                } 
                            } 
                            $o = "<br />";
                            $o .= '<h4>' . $title . '</h4><br />' ;
                            $o .= "<form name=\"errorForm\" method=\"post\" action=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main\"><table id=\"errorForm\" align=\"center\" summary=\"\">";
                            $o .= "<tr><td align=\"center\">&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\">" . $plugin_tx[$plugin]['msg_delete_form1'] . " <b>" . $formName . "</b> " . $plugin_tx[$plugin]['msg_delete_form2'] . "</td></tr>";
                            $o .= "<tr><td align=\"center\">&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_ok'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main\"' /></td></tr>";
                            $o .= "</table></form>";
                        } 
                        else
                        {
                            $o = errorbox($title, $plugin_tx[$plugin]['error_open_file1'] . " <b>forms.dat</b> " . $plugin_tx[$plugin]['error_open_file2'], $cboDefinedForms);
                        } 
                    } 
                    else
                    {
                        if ($selectedform != 0 || !isset($selectedform))
                        {
                            $o = "<br />";
                            $o .= '<h4>' . $title . '</h4><br />' ;
                            $o .= "<form name=\"delForm\" method=\"post\" action=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;action=deleteform\"><table id=\"deleteForm\" align=\"center\" summary=\"\">";
                            $o .= "<tr><td align=\"center\">&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\">" . $plugin_tx[$plugin]['msg_confirm_delete1'] . " <b>" . $formName . "</b> " . $plugin_tx[$plugin]['msg_confirm_delete2'] . "</td></tr>";
                            $o .= "<tr><td align=\"center\">&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\"><input type=\"submit\" value=\"" . $plugin_tx[$plugin]['forms_btn_yes'] . "\" />&nbsp;&nbsp;<input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_no'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main&amp;selectedform=$selectedform\"' /></td></tr>
                            <input type=\"hidden\" name=\"frmdelete\" value=\"1\" />";
                            $o .= "</table></form>";
                        } 
                        else
                        {
                            $o = "<br />";
                            $o .= '<h4>' . $title . '</h4><br />' ;
                            $o .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;action=deleteform\">";
                            $o .= "<tr><td align=\"center\">&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\">" . $plugin_tx[$plugin]['error_no_form_delete'] . "</td></tr>";
                            $o .= "<tr><td align=\"center\">&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_goback'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main\"' /></td></tr>";
                            $o .= "</form></table>";
                        } 
                    } 
                    break;
                case "updatefields":
                    global $frmnew, $numberOfFields, $rows, $selectedform;
                    $title = ucfirst($plugin_tx[$plugin]['forms_btn_update']);
                    $old_selectedform = $selectedform;

                    if ($frmnew == 1)
                    {
                        unset($selectedform);
                    } 
                    if ($fieldupdate != 1)
                    {
                        $o = "<br />";
                        $o .= '<h4>' . $title . '</h4><br />' ;
                        $o .= "<form name=\"modifyfields\" method=\"post\" action=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;frmnew=" . $frmnew . "&amp;formID=" . $formID . "&amp;action=" . $action . "\"><table id=\"tblfieldsForm\" align=\"center\" summary=\"\">";
                        $o .= "<tr><td><b>" . $plugin_tx[$plugin]['forms_#_fields'] . "</b>&nbsp;&nbsp;<input type=\"text\" name=\"rows\" value=\"$rows\" /></td></tr>";
                        $o .= "<tr><td>&nbsp;</td></tr>";
                        $o .= "<tr><td align=\"center\"><input type=\"submit\" value=\"" . $plugin_tx[$plugin]['forms_btn_ok'] . "\" />&nbsp;&nbsp;<input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_cancel'] . "\" onclick='location.href=\"$sn?&amp;$plugin&amp;admin=plugin_main&amp;selectedform=$old_selectedform\"' /></td></tr>";
                        $o .= "<tr><td><input type=\"hidden\" name=\"fieldupdate\" value=\"1\" /></td></tr>";
                        $o .= "</table></form>";
                    } 
                    else
                    {
                        if (isset($rows) && is_numeric($rows) && is_int($rows + 0))
                        {
                            if ($rows <= 1)
                            {
                                $rows = 2;
                            } 
                            $numberOfFormFields = $rows;
                            unset($action);
                            unset($fieldupdate);
                        } 
                        else
                        {
                            global $plugin, $selectedform, $title;
                            unset($fieldupdate);
                            $message = $plugin_tx[$plugin]['error_#_fields_nonumber'];
                            $o = "<br />";
                            $o .= '<h4>' . $title . '</h4>' ;
                            $o .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"\">";
                            $o .= "<tr><td>&nbsp;</td></tr>";
                            $o .= "<tr><td>$message</td></tr>";
                            $o .= "<tr><td>&nbsp;</td></tr>";
                            $o .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_ok'] . "\" onclick='location.href=\"" . $sn . "?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;action=" . $action . "&amp;frmnew=" . $frmnew . "&amp;formID=" . $formID . "\"' /></td></tr>";
                            $o .= "</form></table>";
                        } 
                    } 
                    break;
                default: 
                    // echo $action;
                    break;
            } 
        } 
        if ($action != "deleteform" && $action != "saveform" && $action != "updatefields")
        { 
            // BUILD THE FORM CONFIGURATOR
            // Link the ADVANCEDFORM javascript file
            $hjs = '<script type="text/javascript" src="' . $pth['folder']['plugins'] . $plugin . '/forms.js"></script>'; 
            // Set table colum field width
            $fieldWidth = 120; 
            // Test the number of fields in the saved form and compair it with the updated rows
            if (isset($numberOfFormFields))
            {
                $rows = $numberOfFormFields;
            } 
            else
            {
                if (!isset($rows))
                {
                    $rows = 2;
                    $numberOfFormFields = $rows;
                } 
                else
                {
                    if (isset($rows) && is_numeric($rows) && is_int($rows + 0))
                    {
                        $numberOfFormFields = $rows;
                    } 
                    else
                    {
                        $rows = 2;
                        $numberOfFormFields = $rows;
                    } 
                } 
            } 
            // Set the Plugin title
            // header('Content-Type: text/html; charset='.$plugin_tx[$plugin]['charset']);
            $title = ucfirst($plugin_tx[$plugin]['menu_main']);
            $o .= '<h4>' . $title . '</h4>' ;
            $o .= "<form name=\"APP\" method=\"post\" action=\"\">
                <input type=\"hidden\" name=\"rows\" value=\"$rows\" />
                <input type=\"hidden\" name=\"formID\" value=\"$formID\" />
                <input type=\"hidden\" name=\"frmnew\" value=\"$frmnew\" />
                <input type=\"hidden\" name=\"selectedform\" value=\"$cboDefinedForms\" />
                <input type=\"hidden\" name=\"FormDefinitionLineID\" size=\"4\" value=\"$FormDefinitionLineID\" onfocus=\"this.blur()\" />
                <input type=\"hidden\" name=\"FormFieldsLineID\" size=\"4\" value=\"$FormFieldsLineID\" onfocus=\"this.blur()\" />";
            $o .= "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" align=\"center\" summary=\"\">" ;
            $o .= "<tr>" ;
            // $o .="<tr><td></td></tr>";
            $o .= "<td width=\"44%\" height=\"15\"><b>" . $plugin_tx[$plugin]['forms_available'] . "</b></td>" ;
            $o .= "<td height=\"15\">&nbsp;</td>" ;
            $o .= "<td height=\"15\" align=\"left\">" . display_defined_forms();
            $o .= "&nbsp;&nbsp;<a href=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;action=newform\"><img src=\"" . $pth['folder']['pluginsimages'] . "btn_newform.png\" alt=\"" . $plugin_tx[$plugin]['forms_btn_new'] . "\" /></a>" ;
            $o .= "&nbsp;&nbsp;<a href=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;action=deleteform\"><img src=\"" . $pth['folder']['pluginsimages'] . "btn_delform.png\" alt=\"" . $plugin_tx[$plugin]['forms_btn_delete'] . "\" /></a>" ;
            $o .= "</td>" ;
            $o .= "</tr></table>" ;
            $o .= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" summary=\"\">" ;
            $o .= "<tr>" ;
            $o .= "<td width=\"100\" height=\"15\"><b>" . $plugin_tx[$plugin]['forms_name'] . "</b></td>" ;
            $o .= "<td width=\"3\" height=\"15\">&nbsp;</td>" ;
            $o .= "<td width=\"155\" height=\"15\"><input type=\"text\" name=\"formName\" size=\"60\" maxlength=\"60\" value=\"$formName\" tabindex=\"2\" /></td>" ;
            $o .= "</tr>" ;
            $o .= "<tr>" ;
            $o .= "<td width=\"100\" height=\"15\"><b>" . $plugin_tx[$plugin]['forms_title'] . "</b></td>" ;
            $o .= "<td width=\"3\" height=\"15\">&nbsp;</td>" ;
            $o .= "<td width=\"150\" height=\"15\"><input type=\"text\" name=\"formTitle\" size=\"60\" maxlength=\"150\" value=\"$formTitle\" tabindex=\"3\" /></td>" ;
            $o .= "</tr>" ;
            $o .= "<tr>" ;
            $o .= "<td height=\"15\"><b>" . $plugin_tx[$plugin]['forms_#_fields'] . "</b></td>" ;
            $o .= "<td height=\"15\">&nbsp;</td>" ;
            $o .= "<td height=\"15\"><input type=\"text\" name=\"numberOfFormFields\" size=\"4\" maxlength=\"4\" value=\"" . $numberOfFormFields . "\" onfocus=\"this.blur()\" tabindex=\"4\" />" ;
            $o .= "&nbsp;&nbsp;&nbsp;<a href=\"$sn?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selectedform . "&amp;action=updatefields&amp;frmnew=" . $frmnew . "&amp;formID=" . $formID . "\"><img src=\"" . $pth['folder']['pluginsimages'] . "btn_newform.png\" alt=\"" . $plugin_tx[$plugin]['forms_btn_update'] . "\" /></a></td>" ;
            $o .= "</tr>" ;
            $o .= "<tr><td colspan=\"5\">" . $plugin_tx[$plugin]['forms_informationn'] . "</td></tr>";
            $o .= "<tr><td colspan=\"5\">" . tag("hr width=\"100%\" size=\"1\" align=\"center\" noshade") . "</td></tr></table>";
            $o .= "<table summary=\"\"><tr><td width=\"5\">&nbsp;</td><td><div style='vertical-align: center; width: $fieldWidth px;'><b>" . $plugin_tx[$plugin]['forms_field_label'] . "</b></div></td><td><div style='vertical-align: center; width: $fieldWidth px;'><b>" . $plugin_tx[$plugin]['forms_field_name'] . "</b></div></td><td><div style='vertical-align: center; width: $fieldWidth px;'><b>" . $plugin_tx[$plugin]['forms_field_type'] . "</b></div></td><td><div style='vertical-align: center; width: $fieldWidth px;'><b>" . $plugin_tx[$plugin]['forms_field_value'] . "</b></div></td><td><div style='vertical-align: center;'><b>" . $plugin_tx[$plugin]['forms_field_required'] . "</b></div></td></tr>";
            if (isset($numberOfFormFields))
            {
                $rows = $numberOfFormFields;
            } 
            else
            {
                $rows = 2;
            } 
            $path = $pth['folder']['plugins'] . $plugin;
            for($i = 1; $i <= $rows; $i++)
            {
                $fieldID = sprintf("%02d", $i);
                $checked = ($fieldRequired[$i] == "on")?"CHECKED":null;
                $o .= "<tr>
                    <td><div align=\"right\"><b>$fieldID.</b></div></td>
                    <td><input type=\"text\" size=\"11\" id=\"fieldLabel" . $i . "\" name=\"fieldLabel[$i]\" style=\"width: $fieldWidth px;\" value=\"$fieldLabel[$i]\" onchange=\"setFieldName($i,this.value)\" /></td>
                    <td><input type=\"text\" size=\"11\" id=\"fieldName" . $i . "\" name=\"fieldName[$i]\" style=\"width: $fieldWidth px;\" value=\"$fieldName[$i]\" onblur=\"uniqueFieldName(this.value,$i)\" /></td>
                    <td>" . display_fieldtype("fieldType[$i]", $fieldType[$i]) . "</td>";
                // Start Modified 27/10/2005 [JAT] - added this.blur() to the onclick event // -->
                $o .= "<td><input type=\"text\" size=\"15\" id=\"fieldValue" . $i . "\" name=\"fieldValue[$i]\" style=\"width: $fieldWidth px;\" value=\"$fieldValue[$i]\" READONLY onclick=\"this.blur();checkFieldType('$i','$path','$sl')\" /></td>
                    <td><div align=\"center\"><input id=\"fieldRequired" . $i . "\" type=\"checkbox\" name=\"fieldRequired[$i]\" $checked /></div></td>
                    </tr>";
            } 
            // Start Modified 27/10/2005 [JAT] - added this.blur() to the onclick event // -->
            $o .= "</table>";
            $o .= ""; 
            // $o .="</table>";
            $o .= "<div>&nbsp;</div>";
            $o .= "<div align=\"center\"><input type=\"hidden\" name=\"action\" value=\"saveform\" /><input type=\"submit\" name=\"btnSave\" value=\"" . ucfirst($tx['action']['save']) . "\" /></div>" ;
            $o .= "</form>"; 
            // END BUILD THE FORM CONFIGURATOR
        } 
    } 
} 
function display_fieldtype($tmpFieldType, $selectedValue)
{
    global $aFieldType, $i, $pth, $plugin;
    $path = $pth['folder']['plugins'] . $plugin;
    // $t =  "\n<select id=\"fieldType".$i."\" name=\"".$tmpFieldType."\" onblur=\"checkFieldType('$i','$path')\">\n" ;
    $t = "\n<select id=\"fieldType" . $i . "\" name=\"" . $tmpFieldType . "\" >\n" ;
    for($s = 0; $s < count($aFieldType);$s ++)
    {
        $selected = trim(strtolower($aFieldType[ $s ])) == trim(strtolower($selectedValue)) ? " selected " : "" ;
        $t .= "<option value=\"" . HtmlSpecialChars($aFieldType[$s]) . "\"" . $selected . ">" . $aFieldType[$s] . "</option>\n" ;
    } 
    $t .= "</select>\n" ;
    return($t);
} 
function display_defined_forms()
{
    global $pth, $DefinedForms, $tmpFormsName, $selectedform, $cboDefinedForms, $plugin;
    readFormDefinitions();
    $t = "\n<select id=\"cboDefinedForms\" name=\"cboDefinedForms\" onchange=\"selectForm(this.value);\">\n";
    $maxForms = count($DefinedForms);
    for($s = 0;$s <= $maxForms;$s++)
    {
        $selected = ($s == $selectedform)?"SELECTED":null;
        $t .= "<option value=\"$s\" $selected >" . $tmpFormsName[$s] . "</option>\n";
    } 
    $t .= "</select>\n" ;
    return($t);
} 
function label2name($t)
{
    $patterns = array("/ +/");
    $replace = array("_");
    return preg_replace($patterns, $replace, $t);
} 
function makeUniqueID()
{
    $md5 = md5(uniqid(srand(time()))) ;
    return date("Ymd") . "-" . substr($md5, 0, 4) ;
} 
function readFormDefinitions()
{
    global $pth, $tmpFormsName, $tmpFormsTitle, $tmpFormsNumberOfFields, $tmpFormsID, $DefinedForms, $plugin, $plugin_tx; 
    // Read all available Form Definitions from file
    if (filesize($pth['folder']['pluginsdata'] . "forms.dat") > 0)
    {
        $DefinedForms = file($pth['folder']['pluginsdata'] . "forms.dat");
    } 
    // Set the default value for the dropdown list
    $tmpFormsName[] = $plugin_tx[$plugin]['forms_select'];
    $tmpFormsTitle[] = "";
    $tmpFormsNumberOfFields[] = 2;
    $tmpFormsID[] = "";
    if (filesize($pth['folder']['pluginsdata'] . "forms.dat") > 0)
    { 
        // Load available Form Definitions metadata into array's
        // FormName - FormTitle - FormNumberOfFields - formID
        while (list($key, $tmpFormDataLine) = each($DefinedForms))
        {
            $tmpFormsArray = unserialize($tmpFormDataLine);
            $tmpFormsName[] = $tmpFormsArray[0];
            $tmpFormsTitle[] = $tmpFormsArray[1];
            $tmpFormsNumberOfFields[] = $tmpFormsArray[2];
            $tmpFormsID[] = $tmpFormsArray[3];
        } 
    } 
    return (true);
} 
function errorbox($title, $message, $selected_form)
{
    global $plugin, $selectedform, $plugin_tx, $cboSelectedForm;

    $t = "<br />";
    $t .= "<h4>" . $title . "</h4>" ;
    $t .= "<table id=\"errorForm\" align=\"center\" summary=\"\"><form name=\"errorForm\" method=\"post\" action=\"\">";
    $t .= "<tr><td>&nbsp;</td></tr>";
    $t .= "<tr><td>$message</td></tr>";
    $t .= "<tr><td>&nbsp;</td></tr>";
    $t .= "<tr><td align=\"center\"><input type=\"button\" value=\"" . $plugin_tx[$plugin]['forms_btn_ok'] . "\" onclick='location.href=\"" . $sn . "?&amp;" . $plugin . "&amp;admin=plugin_main&amp;selectedform=" . $selected_form . "\"' /></td></tr>";
    $t .= "</form></table>";
    return($t);
} 

?>